;===============================================================================
;
;	LED}gbNX(10x10)\
;
;		Author		: K.Takahashi(tokoya)
;		Version		: 0.1
;		Last Update	: 2001/07/04
;		Target		: AT90S2313
;		Comment		: ONbN4MHzgp
;
;	2000/07/04	: 
;	2000/07/12	: UARTR}hݒ
;
;===============================================================================

.include "2313def.inc"

.equ	CLR		= 4		; PD4
.equ	CLK		= 5		; PD5
.equ	DATA		= 6		; PD6

.equ	MSG_MAX		= 64

.equ	TIM0_SET	= 256-31	; 4000000Hz/ 256/ 31500Hz(  2mSec)
.equ	TIM1_SET0	= 65536-195	; 4000000Hz/1024/195 20Hz( 50mSec)
.equ	TIM1_SET1	= 65536-390	; 4000000Hz/1024/390 10Hz(100mSec)
.equ	TIM1_SET2	= 65536-781	; 4000000Hz/1024/781  5Hz(200mSec)

.def	pat_ptr_h	= r10
.def	pat_ptr_l	= r11
.def	msg_ptr_h	= r12
.def	msg_ptr_l	= r13
.def	scr_speed_h	= r14
.def	scr_speed_l	= r15
.def	tp_0		= r16
.def	tp_1		= r17
.def	tp_2		= r18
.def	row_count	= r19
.def	scr_count	= r20
.def	tp_send		= r21
.def	cmd_mode	= r22
.def	str_len		= r23
.def	str_rx		= r24

.DSEG
.ORG	$60
;---------------------------------------
;	SRAM
;---------------------------------------
PAT_BUF:			; 0      7 0------- -1 
		.byte	3*10	; xxxxxxxx xxxxxxxx xxxxxxxx
MSG_BUF:
		.byte	MSG_MAX+1

.CSEG
.ORG	$0
		rjmp	RESET
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	TIM1_OVF			; ^C}1I[o[t[荞
		rjmp	TIM0_OVF			; ^C}0I[o[t[荞
		rjmp	UART_RXC			; UARTM
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY
DUMMY:
		reti

;---------------------------------------
;	
;---------------------------------------
RESET:
		cli

		ldi	tp_0,low(RAMEND)		; X^bN|C^ݒ
		out	SPL,tp_0

		ldi	tp_0,0b11111111			; |[gao͂ɐݒ
		out	DDRB,tp_0

		ldi	tp_0,0b01111111			; |[gco͂ɐݒ
		out	DDRD,tp_0
		sbi	PORTD,CLR
		sbi	PORTD,CLK
		cbi	PORTD,DATA

		rcall	CLEAR_BUF			; \p^[obt@NA
		rcall	SET_MSG				; EEPROMSRAM֕Rs[
		ldi	tp_0,low(SPEED_SET)
		rcall	EEPROM_READ
		mov	tp_0,tp_1
		rcall	SCROLL_SET			; XN[xݒ

		ldi	tp_0,0b10011000			; MAM荞݋
		out	UCR,tp_0
		ldi	tp_0,25				; NbN4MHzUBRRl(9600bps)
		out	UBRR,tp_0

		ldi	tp_0,TIM0_SET
		out	TCNT0,tp_0
		ldi	tp_0,(1<<CS02)			; NbN1/256
		out	TCCR0,tp_0

		clr	tp_0				; OC1gpAPWM֎~
		out	TCCR1A,tp_0
		ldi	tp_0,(1<<CS12)|(1<<CS10)	; NbN1/1024
		out	TCCR1B,tp_0
		out	TCNT1H,scr_speed_h		; XN[xݒ
		out	TCNT1L,scr_speed_l

		ldi	tp_0,(1<<TOIE0)|(1<<TOIE1)	; ^C}荞݂gp
		out	TIMSK,tp_0

		cbi	PORTD,CLR			; VtgWX^
		sbi	PORTD,CLR
		sbi	PORTD,DATA
		cbi	PORTD,CLK
		sbi	PORTD,CLK
		cbi	PORTD,DATA

		rcall	SET_1ST				; ŏ̈ꕶZbg
		rcall	DISP_1ST			; ŏ̈s\
		clr	cmd_mode
		clr	str_len

		sei					; 荞݋

;---------------------------------------
;	C[v
;---------------------------------------
MAIN:
		rjmp	MAIN

;---------------------------------------
;	p^[obt@NA
;---------------------------------------
CLEAR_BUF:
		ldi	ZH,high(PAT_BUF)		; p^[obt@
		ldi	ZL,low(PAT_BUF)			; p^[obt@
		ldi	tp_0,30
		clr	tp_1
CLEAR_BUF_0:
		st	Z+,tp_1
		dec	tp_0
		brne	CLEAR_BUF_0

		ret

;---------------------------------------
;	^C}[0(8Bit)荞
;---------------------------------------
TIM0_OVF:
		in	r0,SREG				; SREGWX^Ҕ
		push	r0
		push	tp_0

		dec	row_count
		brne	TIM0_OVF_0
		sbi	PORTD,DATA
		cbi	PORTD,CLK
		sbi	PORTD,CLK
		cbi	PORTD,DATA
		ldi	ZH,high(PAT_BUF+1)		; p^[obt@
		ldi	ZL,low(PAT_BUF+1)		; p^[obt@
		ldi	row_count,10
		rjmp	TIM0_OVF_1
TIM0_OVF_0:
		cbi	PORTD,CLK
		sbi	PORTD,CLK
		mov	ZH,pat_ptr_h
		mov	ZL,pat_ptr_l
TIM0_OVF_1:
		rcall	DISP_ROW
		mov	pat_ptr_h,ZH
		mov	pat_ptr_l,ZL
		ldi	tp_0,TIM0_SET
		out	TCNT0,tp_0

		pop	tp_0
		pop	r0				; SREGWX^𕜋A
		out	SREG,r0
		reti

;---------------------------------------
;	^C}[1(16Bit)荞
;---------------------------------------
TIM1_OVF:
		in	r0,SREG				; SREGWX^Ҕ
		push	r0
		push	tp_0
		push	tp_1

		ldi	YH,high(PAT_BUF)		; p^[obt@
		ldi	YL,low(PAT_BUF)			; p^[obt@
		ldi	tp_1,10
TIM1_OVF_0:
		ld	tp_0,Y				; XN[
		lsl	tp_0
		st	Y+,tp_0
		ld	tp_0,Y
		rol	tp_0
		st	Y+,tp_0
		ld	tp_0,Y
		rol	tp_0
		st	Y+,tp_0
		dec	tp_1
		brne	TIM1_OVF_0

		inc	scr_count
		cpi	scr_count,6
		brne	TIM1_OVF_2
		clr	scr_count

		mov	YH,msg_ptr_h
		mov	YL,msg_ptr_l
		ld	tp_0,Y+
		tst	tp_0
		brne	TIM1_OVF_1
		ldi	YH,high(MSG_BUF)		; \
		ldi	YL,low(MSG_BUF)			; \
		ld	tp_0,Y+
TIM1_OVF_1:
		rcall	SET_PATTERN
		mov	msg_ptr_h,YH
		mov	msg_ptr_l,YL

TIM1_OVF_2:
		out	TCNT1H,scr_speed_h
		out	TCNT1L,scr_speed_l

		pop	tp_1
		pop	tp_0
		pop	r0				; SREGWX^𕜋A
		out	SREG,r0
		reti

;---------------------------------------
;	\
;---------------------------------------
DISP_ROW:
		ld	tp_2,Z+
		ld	tp_1,Z+
		inc	ZL
		com	tp_1
		lsl	tp_1
		lsl	tp_1
		andi	tp_1,0b00001100
		in	tp_0,PIND
		andi	tp_0,0b01110011
		or	tp_1,tp_0
		com	tp_2
		out	PORTD,tp_1
		out	PORTB,tp_2

		ret

;---------------------------------------
;	\p^[obt@ɓ]
;---------------------------------------
SET_PATTERN:
		push	YH
		push	YL
		push	ZH
		push	ZL

		ldi	ZH,high(PATTERN_TBL)		; p^[e[u
		ldi	ZL,low(PATTERN_TBL)
		subi	tp_0,0x20			; p^[0x20Ȃ̂ŕ␳
		clr	tp_1
		lsl	tp_0
		rol	tp_1
		lsl	tp_0
		rol	tp_1
		add	ZL,tp_0
		adc	ZH,tp_1
		lsl	ZL
		rol	ZH
		ldi	YH,high(PAT_BUF)		; \obt@
		ldi	YL,low(PAT_BUF)

		clr	tp_0
		st	Y,tp_0
		subi	YL,-3
		ldi	tp_1,8
SET_PATTERN_0:
		lpm
		ld	tp_0,Y
		or	tp_0,r0
		st	Y,tp_0
		ldi	tp_0,1
		add	ZL,tp_0
		clr	tp_0
		adc	ZH,tp_0
		subi	YL,-3
		dec	tp_1
		brne	SET_PATTERN_0
		clr	tp_0
		st	Y,tp_0

		pop	ZL
		pop	ZH		
		pop	YL
		pop	YH		
		ret

;---------------------------------------
;	EEPROM̕obt@ɓ]
;---------------------------------------
SET_MSG:
		ldi	tp_0,low(MSG_SET)
		ldi	YH,high(MSG_BUF)		; bZ[Wobt@
		ldi	YL,low(MSG_BUF)
		clr	tp_2
SET_MSG_0:
		rcall	EEPROM_READ
		st	Y+,tp_1
		inc	tp_0
		inc	tp_2
		cpi	tp_2,MSG_MAX
		brsh	SET_MSG_1
		tst	tp_1
		brne	SET_MSG_0
SET_MSG_1:
		ret

;---------------------------------------
;	FlashROM(Z)->SRAM(Y)փRs[
;---------------------------------------
COPY_FTOS:
		push	tp_0
		push	tp_1
		ldi	tp_0,1
		clr	tp_1
COPY_FTOS_0:
		lpm
		add	ZL,tp_0
		adc	ZH,tp_1
		st	Y+,r0
		tst	r0
		brne	COPY_FTOS_0
		pop	tp_1
		pop	tp_0
		ret		

;---------------------------------------
;	ŏ̈ꕶZbg
;---------------------------------------
SET_1ST:
		ldi	YH,high(MSG_BUF)		; \
		ldi	YL,low(MSG_BUF)			; \
		ld	tp_0,Y+
		rcall	SET_PATTERN			; ŏ̕p^[Zbg
		mov	msg_ptr_h,YH
		mov	msg_ptr_l,YL
		ret

;---------------------------------------
;	ŏ̈\
;---------------------------------------
DISP_1ST:
		ldi	ZH,high(PAT_BUF+1)		; p^[obt@
		ldi	ZL,low(PAT_BUF+1)		; p^[obt@
		rcall	DISP_ROW			; ŏ̈\
		mov	pat_ptr_h,ZH
		mov	pat_ptr_l,ZL
		ldi	row_count,10			; \sJE^
		clr	scr_count			; XN[JE^
		ret

;---------------------------------------
;	EEPROMPoCgǂݍ
;---------------------------------------
EEPROM_READ:
		sbic	EECR,EEWE
		rjmp	EEPROM_READ
		out	EEAR,tp_0
		sbi	EECR,EERE
		in	tp_1,EEDR
		ret

;---------------------------------------
;	EEPROMւPoCg
;
;		荞ݏ
;		CALLƂ
;		EEPROM_WRITE2g
;---------------------------------------
EEPROM_WRITE:
		sbic	EECR,EEWE
		rjmp	EEPROM_WRITE
		out	EEAR,tp_0
		out	EEDR,tp_1
		cli
		sbi	EECR,EEMWE
		sbi	EECR,EEWE
		sei
		ret

EEPROM_WRITE2:
		sbic	EECR,EEWE
		rjmp	EEPROM_WRITE2
		out	EEAR,tp_0
		out	EEDR,tp_1
		sbi	EECR,EEMWE
		sbi	EECR,EEWE
		ret

;---------------------------------------
;	XN[xݒ
;---------------------------------------
SCROLL_SET:
		push	tp_0
		tst	tp_0
		brne	SCROLL_SET_0
		ldi	tp_0,high(TIM1_SET0)
		mov	scr_speed_h,tp_0
		ldi	tp_0,low(TIM1_SET0)
		mov	scr_speed_l,tp_0
		rjmp	SCROLL_SET_EXIT

SCROLL_SET_0:
		dec	tp_0
		brne	SCROLL_SET_1
		ldi	tp_0,high(TIM1_SET1)
		mov	scr_speed_h,tp_0
		ldi	tp_0,low(TIM1_SET1)
		mov	scr_speed_l,tp_0
		rjmp	SCROLL_SET_EXIT

SCROLL_SET_1:
		ldi	tp_0,high(TIM1_SET2)
		mov	scr_speed_h,tp_0
		ldi	tp_0,low(TIM1_SET2)
		mov	scr_speed_l,tp_0

SCROLL_SET_EXIT:
		pop	tp_0
		ret

;---------------------------------------
;	M
;---------------------------------------
SEND:
		sbis	USR,UDRE			; MI܂ő҂
		rjmp	SEND
		out	UDR,tp_send
		ret

SEND_HEX:
		push	tp_send
		lsr	tp_send
		lsr	tp_send
		lsr	tp_send
		lsr	tp_send
		cpi	tp_send,10
		brlo	SEND_HEX_0
		subi	tp_send,-7			; +7
SEND_HEX_0:
		subi	tp_send,-0x30			; +0x30
		rcall	SEND
		pop	tp_send
		andi	tp_send,0x0F
		cpi	tp_send,10
		brlo	SEND_HEX_1
		subi	tp_send,-7
SEND_HEX_1:
		subi	tp_send,-0x30
		rcall	SEND
		ret

;---------------------------------------
;	VAM荞
;---------------------------------------
UART_RXC:
		in	r0,SREG				; SREGWX^Ҕ
		push	r0
		push	tp_0
		push	tp_1
		push	tp_send

		in	tp_0,UDR
		tst	cmd_mode
		breq	UART_RXC_00
		rjmp	CMD_RX
UART_RXC_00:
		cpi	tp_0,'?'
		brne	UART_RXC_0
		ldi	tp_send,'L'
		rcall	SEND
		ldi	tp_send,'E'
		rcall	SEND
		ldi	tp_send,'D'
		rcall	SEND
		ldi	tp_send,'-'
		rcall	SEND
		ldi	tp_send,'M'
		rcall	SEND
		ldi	tp_send,'A'
		rcall	SEND
		ldi	tp_send,'T'
		rcall	SEND
		ldi	tp_send,'R'
		rcall	SEND
		ldi	tp_send,'I'
		rcall	SEND
		ldi	tp_send,'X'
		rcall	SEND
		ldi	tp_send,'1'
		rcall	SEND
		ldi	tp_send,'.'
		rcall	SEND
		ldi	tp_send,'0'
		rcall	SEND
		rjmp	UART_RXC_EXIT

UART_RXC_0:
		cpi	tp_0,'S'			; XN[x
		breq	UART_RXC_1
		cpi	tp_0,'M'			; bZ[W
		breq	UART_RXC_2
		cpi	tp_0,'R'			; Zbg
		breq	UART_RXC_3
		rjmp	UART_RXC_EXIT
UART_RXC_1:
		mov	cmd_mode,tp_0
		rjmp	UART_RXC_EXIT

UART_RXC_2:
		mov	cmd_mode,tp_0
		rcall	CLEAR_BUF			; \p^[obt@NA
		ldi	ZL,low(MSG1*2)
		ldi	ZH,high(MSG1*2)
		ldi	YL,low(MSG_BUF)
		ldi	YH,low(MSG_BUF)
		rcall	COPY_FTOS
		rcall	SET_1ST
		rcall	DISP_1ST
		clr	str_len
		ldi	str_rx,low(MSG_SET)
		rjmp	UART_RXC_EXIT

UART_RXC_3:
		ldi	ZL,low(MSG0*2)			; ftHgEEPROMɏ
		ldi	ZH,high(MSG0*2)
		ldi	str_rx,low(MSG_SET)
UART_RXC_4:
		lpm
		mov	tp_1,r0
		mov	tp_0,str_rx
		rcall	EEPROM_WRITE2
		tst	r0
		breq	UART_RXC_5
		ldi	tp_1,1
		add	ZL,tp_1
		clr	tp_1
		adc	ZH,tp_1
		inc	str_rx
		rjmp	UART_RXC_4
UART_RXC_5:
		ldi	tp_0,low(SPEED_SET)		; ftHgXN[xEEPROMɏ
		ldi	tp_1,1
		rcall	EEPROM_WRITE2
		ldi	tp_0,1
		rcall	SCROLL_SET
		rcall	CLEAR_BUF			; \p^[obt@NA
		rcall	SET_MSG				; EEPROMSRAM֕Rs[
		rcall	SET_1ST
		rcall	DISP_1ST

UART_RXC_EXIT:
		pop	tp_send
		pop	tp_1
		pop	tp_0
		pop	r0				; SREGWX^𕜋A
		out	SREG,r0
		reti					; 荞݂߂

;---------------------------------------
;	R}hMs
;---------------------------------------
CMD_RX:
		cpi	cmd_mode,'S'			; XN[x
		breq	CMD_SPEED
		cpi	cmd_mode,'M'			; bZ[Wݒ
		breq	CMD_MSG
		rjmp	UART_RXC_EXIT

CMD_SPEED:
		subi	tp_0,0x30
		rcall	SCROLL_SET
		mov	tp_1,tp_0
		ldi	tp_0,low(SPEED_SET)
		rcall	EEPROM_WRITE2			; ݒlEEPROMɏ
		clr	cmd_mode
		rjmp	UART_RXC_EXIT
		
CMD_MSG:
		cpi	tp_0,0x0d			; CRŏI
		breq	CMD_MSG_2
		cpi	tp_0,0x20			; 0x20`0x7FȊO͋̕󔒂ɒu
		brlo	CMD_MSG_0
		cpi	tp_0,0x80
		brlo	CMD_MSG_1
CMD_MSG_0:
		ldi	tp_0,0x20
CMD_MSG_1:
		mov	tp_send,tp_0			; GR[obN
		rcall	SEND
		mov	tp_1,tp_0
		mov	tp_0,str_rx
		rcall	EEPROM_WRITE2
		inc	str_len
		inc	str_rx
		cpi	str_len,MSG_MAX
		brlo	UART_RXC_EXIT
CMD_MSG_2:
		tst	str_len				; ŒłPKv
		breq	CMD_MSG_3
		clr	tp_1
		mov	tp_0,str_rx
		rcall	EEPROM_WRITE2			; EEPROM֏
CMD_MSG_3:
		cli
		rcall	CLEAR_BUF			; \p^[obt@NA
		rcall	SET_MSG				; EEPROMSRAM֕Rs[
		rcall	SET_1ST
		rcall	DISP_1ST
		sei
		clr	cmd_mode
		rjmp	UART_RXC_EXIT

;---------------------------------------
;	bZ[W
;---------------------------------------
MSG0:
		.DB	"The quick brown fox jumps over the lazy dog. ",0x00	; ftHg
MSG1:
		.DB	"SET-MSG-",0x00

;---------------------------------------
;	p^[e[u
;---------------------------------------
PATTERN_TBL:
		.DB	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,	;  
		.DB	0x04,0x04,0x04,0x04,0x04,0x00,0x04,0x00,	; !
		.DB	0x0A,0x0A,0x0A,0x00,0x00,0x00,0x00,0x00,	; "
		.DB	0x0A,0x0A,0x1F,0x0A,0x1F,0x0A,0x0A,0x00,	; #
		.DB	0x04,0x0F,0x14,0x0E,0x05,0x1E,0x04,0x00,	; $
		.DB	0x18,0x19,0x02,0x04,0x08,0x13,0x03,0x00,	; %
		.DB	0x0C,0x12,0x14,0x08,0x15,0x12,0x0D,0x00,	; &
		.DB	0x0C,0x04,0x08,0x00,0x00,0x00,0x00,0x00,	; '
		.DB	0x02,0x04,0x08,0x08,0x08,0x04,0x02,0x00,	; (
		.DB	0x08,0x04,0x02,0x02,0x02,0x04,0x08,0x00,	; )
		.DB	0x00,0x0A,0x04,0x1F,0x04,0x0A,0x00,0x00,	; *
		.DB	0x00,0x04,0x04,0x1F,0x04,0x04,0x00,0x00,	; +
		.DB	0x00,0x00,0x00,0x00,0x00,0x0C,0x04,0x08,	; ,
		.DB	0x00,0x00,0x00,0x1F,0x00,0x00,0x00,0x00,	; -
		.DB	0x00,0x00,0x00,0x00,0x00,0x0C,0x0C,0x00,	; .
		.DB	0x00,0x01,0x02,0x04,0x08,0x10,0x00,0x00,	; /
		.DB	0x0E,0x11,0x13,0x15,0x19,0x11,0x0E,0x00,	; 0
		.DB	0x04,0x0C,0x04,0x04,0x04,0x04,0x0E,0x00,	; 1
		.DB	0x0E,0x11,0x01,0x02,0x04,0x08,0x1F,0x00,	; 2
		.DB	0x1F,0x02,0x04,0x02,0x01,0x11,0x0E,0x00,	; 3
		.DB	0x02,0x06,0x0A,0x12,0x1F,0x02,0x02,0x00,	; 4
		.DB	0x1F,0x10,0x1E,0x01,0x01,0x11,0x0E,0x00,	; 5
		.DB	0x06,0x08,0x10,0x1E,0x11,0x11,0x0E,0x00,	; 6
		.DB	0x1F,0x01,0x02,0x04,0x08,0x08,0x08,0x00,	; 7
		.DB	0x0E,0x11,0x11,0x0E,0x11,0x11,0x0E,0x00,	; 8
		.DB	0x0E,0x11,0x11,0x0F,0x01,0x02,0x0C,0x00,	; 9
		.DB	0x00,0x0C,0x0C,0x00,0x0C,0x0C,0x00,0x00,	; :
		.DB	0x00,0x0C,0x0C,0x00,0x0C,0x04,0x08,0x00,	; ;
		.DB	0x01,0x02,0x04,0x08,0x04,0x02,0x01,0x00,	; <
		.DB	0x00,0x00,0x1F,0x00,0x1F,0x00,0x00,0x00,	; =
		.DB	0x10,0x08,0x04,0x02,0x04,0x08,0x10,0x00,	; >
		.DB	0x0E,0x11,0x01,0x02,0x04,0x00,0x04,0x00,	; ?
		.DB	0x0E,0x11,0x01,0x0D,0x15,0x15,0x0E,0x00,	; @
		.DB	0x0E,0x11,0x11,0x11,0x1F,0x11,0x11,0x00,	; A
		.DB	0x1E,0x11,0x11,0x1E,0x11,0x11,0x1E,0x00,	; B
		.DB	0x0E,0x11,0x10,0x10,0x10,0x11,0x0E,0x00,	; C
		.DB	0x1C,0x12,0x11,0x11,0x11,0x12,0x1C,0x00,	; D
		.DB	0x1F,0x10,0x10,0x1E,0x10,0x10,0x1F,0x00,	; E
		.DB	0x1F,0x10,0x10,0x1C,0x10,0x10,0x10,0x00,	; F
		.DB	0x0E,0x11,0x10,0x10,0x13,0x11,0x0E,0x00,	; G
		.DB	0x11,0x11,0x11,0x1F,0x11,0x11,0x11,0x00,	; H
		.DB	0x0E,0x04,0x04,0x04,0x04,0x04,0x0E,0x00,	; I
		.DB	0x07,0x02,0x02,0x02,0x02,0x12,0x0C,0x00,	; J
		.DB	0x11,0x12,0x14,0x18,0x14,0x12,0x11,0x00,	; K
		.DB	0x10,0x10,0x10,0x10,0x10,0x10,0x1F,0x00,	; L
		.DB	0x11,0x1B,0x15,0x11,0x11,0x11,0x11,0x00,	; M
		.DB	0x11,0x11,0x19,0x15,0x13,0x11,0x11,0x00,	; N
		.DB	0x0E,0x11,0x11,0x11,0x11,0x11,0x0E,0x00,	; O
		.DB	0x1E,0x11,0x11,0x1E,0x10,0x10,0x10,0x00,	; P
		.DB	0x0E,0x11,0x11,0x11,0x15,0x12,0x0D,0x00,	; Q
		.DB	0x1E,0x11,0x11,0x1E,0x14,0x12,0x11,0x00,	; R
		.DB	0x0F,0x10,0x10,0x0E,0x01,0x01,0x1E,0x00,	; S
		.DB	0x1F,0x04,0x04,0x04,0x04,0x04,0x04,0x00,	; T
		.DB	0x11,0x11,0x11,0x11,0x11,0x11,0x0E,0x00,	; U
		.DB	0x11,0x11,0x11,0x11,0x11,0x0A,0x04,0x00,	; V
		.DB	0x11,0x11,0x11,0x15,0x15,0x1B,0x11,0x00,	; W
		.DB	0x11,0x11,0x0A,0x04,0x0A,0x11,0x11,0x00,	; X
		.DB	0x11,0x11,0x0A,0x04,0x04,0x04,0x04,0x00,	; Y
		.DB	0x1F,0x01,0x02,0x04,0x08,0x10,0x1F,0x00,	; Z
		.DB	0x07,0x04,0x04,0x04,0x04,0x04,0x07,0x00,	; [
		.DB	0x00,0x10,0x08,0x04,0x02,0x01,0x00,0x00,	; \	;
		.DB	0x1C,0x04,0x04,0x04,0x04,0x04,0x1C,0x00,	; ]
		.DB	0x04,0x0A,0x11,0x00,0x00,0x00,0x00,0x00,	; ^
		.DB	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,	; _
		.DB	0x08,0x04,0x02,0x00,0x00,0x00,0x00,0x00,	; `
		.DB	0x00,0x00,0x0E,0x01,0x0F,0x11,0x0F,0x00,	; a
		.DB	0x10,0x10,0x16,0x19,0x11,0x11,0x1E,0x00,	; b
		.DB	0x00,0x00,0x0E,0x10,0x10,0x11,0x0E,0x00,	; c
		.DB	0x01,0x01,0x0D,0x13,0x11,0x11,0x0F,0x00,	; d
		.DB	0x00,0x00,0x0E,0x11,0x1F,0x10,0x0E,0x00,	; e
		.DB	0x06,0x09,0x08,0x1C,0x08,0x08,0x08,0x00,	; f
		.DB	0x00,0x00,0x0F,0x11,0x11,0x0F,0x01,0x0E,	; g
		.DB	0x10,0x10,0x16,0x19,0x11,0x11,0x11,0x00,	; h
		.DB	0x04,0x00,0x0C,0x04,0x04,0x04,0x0E,0x00,	; i
		.DB	0x02,0x00,0x06,0x02,0x02,0x02,0x12,0x0C,
		.DB	0x08,0x08,0x09,0x0A,0x0C,0x0A,0x09,0x00,	; k
		.DB	0x0C,0x04,0x04,0x04,0x04,0x04,0x0E,0x00,	; l
		.DB	0x00,0x00,0x1A,0x15,0x15,0x11,0x11,0x00,	; m
		.DB	0x00,0x00,0x16,0x19,0x11,0x11,0x11,0x00,	; n
		.DB	0x00,0x00,0x0E,0x11,0x11,0x11,0x0E,0x00,	; o
		.DB	0x00,0x00,0x1E,0x11,0x11,0x1E,0x10,0x10,	; p
		.DB	0x00,0x00,0x0F,0x11,0x11,0x0F,0x01,0x01
		.DB	0x00,0x00,0x16,0x19,0x10,0x10,0x10,0x00,	; r
		.DB	0x00,0x00,0x0E,0x10,0x0E,0x01,0x1E,0x00,	; s
		.DB	0x08,0x08,0x1C,0x08,0x08,0x09,0x06,0x00,	; t
		.DB	0x00,0x00,0x11,0x11,0x11,0x13,0x0D,0x00,	; u
		.DB	0x00,0x00,0x11,0x11,0x11,0x0A,0x04,0x00,	; v
		.DB	0x00,0x00,0x11,0x11,0x15,0x15,0x0A,0x00,	; w
		.DB	0x00,0x00,0x11,0x0A,0x04,0x0A,0x11,0x00,	; x
		.DB	0x00,0x00,0x11,0x11,0x11,0x0F,0x01,0x0E,
		.DB	0x00,0x00,0x1F,0x02,0x04,0x08,0x1F,0x00,	; z
		.DB	0x02,0x04,0x04,0x08,0x04,0x04,0x02,0x00,	; {
		.DB	0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x00,	; |
		.DB	0x08,0x04,0x04,0x02,0x04,0x04,0x08,0x00,	; }
		.DB	0x0D,0x12,0x00,0x00,0x00,0x00,0x00,0x00,	; ~
		.DB	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,	; DEL

.ESEG
.ORG	$0
;---------------------------------------
;	EEPROM
;---------------------------------------
SPEED_SET:
		.DB	1
MSG_SET:
		.DB	"The quick brown fox jumps over the lazy dog. ",0x00